# -*- coding: utf-8 -*-
"""
Created on Tue May  9 19:38:08 2023

@author: user
"""

# Load libraries
import numpy as np
from keras.datasets import imdb
from keras.preprocessing.text import Tokenizer
from keras import models
from keras import layers
import tensorflow as tf
import random
random.seed(0)
np.random.seed(0)
tf.random.set_seed(0)
# Set the number of features we want
number_of_features = 1000
# Load data and target vector from movie review data
(data_train, target_train), (data_test, target_test) = imdb.load_data(num_words=number_of_features)
# Convert movie review data to one-hot encoded feature matrix
tokenizer = Tokenizer(num_words=number_of_features)
features_train = tokenizer.sequences_to_matrix(data_train, mode="binary")
features_test = tokenizer.sequences_to_matrix(data_test, mode="binary")
# Start neural network
network = models.Sequential()
# Add fully connected layer with a ReLU activation function
network.add(layers.Dense(units=16, activation="relu", input_shape=(
number_of_features,)))
# Add fully connected layer with a ReLU activation function
network.add(layers.Dense(units=16, activation="relu"))
# Add fully connected layer with a sigmoid activation function
network.add(layers.Dense(units=1, activation="sigmoid"))
# Compile neural network
network.compile(loss="binary_crossentropy", # Cross-entropy
optimizer="rmsprop", # Root Mean Square Propagation
metrics=["accuracy"]) # Accuracy performance metric
# Train neural network
history = network.fit(features_train, # Features
target_train, # Target vector
epochs=3, # Number of epochs
verbose=1, # Print description after each epoch
batch_size=100, # Number of observations per batch
validation_data=(features_test, target_test)) # Test data

# Make predictions on the test data
predictions = network.predict(features_test)

# Convert predictions to binary values (0 or 1)
binary_predictions = (predictions > 0.5).astype('int')

# Evaluate accuracy, precision, recall, and confusion matrix
from sklearn.metrics import classification_report, confusion_matrix


conf_matrix = confusion_matrix(target_test, binary_predictions)


print("Confusion Matrix:")
print(conf_matrix)
#evaluation
print(classification_report(target_test, binary_predictions))
